#include <stdlib.h>
#include <stdio.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/types.h>
#include "Session.h"

int main(int argc,char **argv) {
	Session s;
	if(argc>=2) {
		if(!strcmp(argv[1],"-a")) {
			char *sid=argv[2];
			for(int i=3;i<argc;i+=2) {
				s.set(argv[i],argv[i+1]);
			}
			addSession(sid,s);
		} else if(!strcmp(argv[1],"-g")) {
			if(getSession(argv[2],s)) {
				cout << s.to_string() <<endl;
				for(int i=3;i<argc;i++) {
					cout << argv[i] << "=" << s.get(argv[i]) << endl;
				}
			} else {
				cout << "No such session\n";
			}
		} else if(!strcmp(argv[1],"-r")) {
			removeSessions();
		} else if(!strcmp(argv[1],"-A")) {
			char *sid=getUniqueId();
			cout << "sid=" << sid << endl;
			for(int i=2;i<argc;i+=2) {
				s.set(argv[i],argv[i+1]);
			}
			addSession(sid,s);
		} else if(!strcmp(argv[1],"-d")) {
			destroy();
		} else if(!strcmp(argv[1],"-i")) {
			vector<string> sid;
			vector<string> data;
			vector<time_t> touched;
			int nsessions,seed;
			getInfo(nsessions,seed,sid,data,touched);
			cout << "nsessions="<<nsessions<<" seed="<<seed<<endl;
			for(int i=0;i<nsessions;i++) {
				cout<<sid[i]<<" | "<<data[i]<<" | "<<ctime(&touched[i]);
			}
		}
	}
}