#ifndef __DATASET_H_
#define __DATASET_H_

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
// C++ includes
#include <string>
#include <vector>
#include <map>

#include "TemplateObject.h"
#include "TemplateVariable.h"
#include "TemplateError.h"

class DataSet: public ObjectContainer {
public:
	DataSet();
	~DataSet();
	virtual TemplateObject *getVal(const string &key);
	virtual bool hasKey(const string &key);
	void add(const string &key,const string val);
	void add(const string &key,int val);
	void add(const string &key,double val);
	void add(const string &key,DataSet *val);
	void setCurrentRow(int row);
	void newRow();
	int  getSize();
private:
	vector<map<string,TemplateObject *> > data; // keeps a vector of rows each one is a hash col=>value
	int current_row;	
};
#endif

