#ifndef __TEMPLATE_H_
#define __TEMPLATE_H_

#include <stdlib.h>
#include <stdio.h>
// C++ includes 
#include <map>
#include <string>
// Project includes
#include "Parser.h"
#include "TemplateObject.h"
#include "TemplateContainer.h"
#include "TemplateVariable.h"
#include "DataSet.h"

class Template;

class Template: public ObjectContainer {
public:
	Template();
	~Template();
	void addVariable(const string &key,const string &val);
	virtual TemplateObject *getVal(const string &key);
	virtual bool hasKey(const string &key);
	void add(const string &,const string &);
	void add(const string &,int val);
	void add(const string &,double val);
	void add(const string &,DataSet *);
	void parse(char *,FILE *out=stdout);
private:
	map<string,TemplateObject *> childs;
};

void doVariable(TemplateContainer *,TemplateObject *,TmplTag &,bool active,FILE *out);
void doDataSet(TemplateContainer *,TemplateObject *,TmplTag &,bool active,FILE *out);
void doTemplate(TemplateContainer *,TemplateObject *,TmplTag &,bool active,FILE *out); 
void doIf(TemplateContainer *,TemplateObject *,TmplTag &,bool active,FILE *out); 

#endif

