#ifndef __TMPLOBJ_H_
#define __TMPLOBJ_H_

#include <string>

typedef enum {DATASET,TEMPLATE,VARIABLE} TemplateObjectType;

class TemplateObject {
public:
	TemplateObject(TemplateObjectType t) { object_type=t; }
	virtual ~TemplateObject() { }
	TemplateObjectType getType() { return object_type; }
private:
	TemplateObjectType object_type;
};

class ObjectContainer : public TemplateObject {
public: 
	ObjectContainer(TemplateObjectType t) : TemplateObject(t) { strict=false; }
	virtual ~ObjectContainer() {}
	virtual TemplateObject *getVal(const string &key)=0;
	virtual bool hasKey(const string &key)=0;
	virtual void useStrict() { strict=true; }
	virtual bool isStrict() { return strict; }
	
protected:
	bool strict;
};

#endif

